
/**
* ui.toolbar
*
* @implement Minimal.View
* @author Code Politan <codepolitan@gmail.com>
*/
ui.toolbar = primish({

	extend: ui.component,

	/*implement: [options, emitter],*/

	name: 'toolbar',
	/**
	 * Initialize Toolbar
	 *
	 * @method _initToolbar
	 * @param {obj}
	 * @api private
	 */
	options: {
		component: 'toolbar',
		klss: 'ui-toolbar',
		element: {
			tag: 'span'
		}
	},

	/**
	 * Constructor
	 * @param  {Object} options [description]
	 * @return {Object}         [description]
	 */
	constructor: function(options){
		console.log(controller);
		this.setOptions(options);

		this.options.tag = 'span';

		console.log(this.options);

		this.component = this.options.component;
		this.trigger('init');

		this._initElement();
		//this._initBinding();

		return this;
	},

	/**
	 * Create a div and a hidden input to receive the selected value
	 * @function _initElement
	 * @extends {_initElement}
	 * @return {[type]} [description]
	 */
	_initElement: function(){
		//console.log('_initElement', this.name);
		//create a new div as input element
		this.parent('_initElement');

		console.log('_initToolbar', this.options, this.element);
		this._initComponent(this.options.component, this.element);
	},

	/**
	 * [_initMore description]
	 * @type {[type]}
	 */
	_initMore: function() {
		//_log('_initMore', this.container, this.control.more, this.toolbar.more);
		if (!this.control || !this.toolbar) return null;

		var timer = null;

		var toolbar = this.toolbar.more;
		var control = this.control.more;

		if (control && toolbar) {

			control.addEvent('press', function(ev) {
				_log('press', ev);
				var coord = control.getCoordinates();
				toolbar.setStyles({
					display: 'inline-block'
				});

				return true;
			});

			toolbar.addEvents({
				mouseleave: function() {
					clearTimeout(timer);
					timer = setTimeout(function() {
						toolbar.setStyle('display', 'none');
					}, 200);
				},
				mouseenter: function() {
					clearTimeout(timer);
				},
				click: function() {
					toolbar.setStyle('display', 'none');
				}
			});
		}
	},

	/**
	 * [_initToolbarComp description]
	 * @type {[type]}
	 */
	_initComponent: function(component, element) {
		var self = this;

		console.log(component, element);

		component._list = component._list || [];

		for (var i= 0; i < component._list.length; i++) {
			var n = component._list[i],
				clss,
				comp,
				opts,
				comps = n.split(/\./);

			if (comps.length > 1) {
				clss = 'ui.'+comps[0];
				name = comps[1];
			} else {
				name = comps[0];
				clss = 'ui.button';
			}

			opts = {
				name: name,
				icon: mnml.icon.button[name] || 'fa-wrench',
				type: 'action'
			};


			if (typeof name == 'string')

			if (!name) continue;

			var	Clss = sick.api.toclss(clss);

			if (clss == 'ui.button')
				opts.text = name;

			console.log('n', n, opts);
			//var role = floor.controller.session.role;
			var inject = true;

			this.options.control = this.options.control || {};

			/*if (!this.options.control[role]) {
				inject = true;
			} else {
				if (!this.options.control[role].disallowed) {
					inject = true;
				} else if (this.options.control[role].disallowed.indexOf(n) > -1) {
					inject = false;
				}
			}
			*/



			if (!inject) continue;

			this.control[name] = new Clss(opts).inject(element);

			/*.addEvents({
				change: function(value) {
					var name =  this.options.name;
					//_log('change', value, this.isEnable());
					if (this.isEnable())
						self.fireEvent(n, value);
				},
				press: function() {
					var name =  this.options.name;
					//_log('press', n, this.isEnable());
					if (this.isEnable()) {
						self.fireEvent('control::'+name, this);
						self.fireEvent(name, [self]);
					}
				}
			});*/
		}
	},

	/**
	 * Add Toolbar
	 *
	 * @method addToolbar
	 * @param {toolbar}
	 * @param {context}
	 * @api public
	 */
	addToolbar: function(toolbar, context) {
		//_log('initToolbar', toolbar, this.container);
		new UI.Toolbar({
			item: item
		}).inject(self.container[toolbar.container]);
	}
});
